//#####################################################################
// Datei: DUOLED.C
//
// Experimente mit einer zweibeinigen Zweifarben-LED und PIC16F84
//
// Die LED hngt an PORTB6 und PORTB7. Vorwiderstand 270 Ohm.
// Wenn man die LED schnell umpolt kommen je nach Tastverhltnis
// unterschiedliche Farben heraus. Man sollte aber nicht zuviel erwarten.
// Zwischen Rot und Grn kommt noch ein nettes Gelb zustande. Und ein
// schmutziges Orange. Aber sieh selbst ;)
//
// Der PIC luft mit 4MHz.
//
//#####################################################################
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 28.11.2002
// Compiler CC5x
//#####################################################################

#include "prozess.h"      /* Der verwendete Prozessor */
#include "delay.c"


// Watchdog off, Power up Timer on, XT Oscillator, Code Protect off
#pragma config |= 0x3FF1 //Configuration Word

#define UP	1
#define DOWN	0

// Hauptprogramm
void main()
{
 unsigned char i,j;
 unsigned char ud; //Mode UP/Down
 
 TRISB=0b00111111; //PB6..7 Ausgnge
 PORTB=0; 

 while(1) // Anfang Programm Endlosschleife
  {
//Beginn stufenloser Farbverlauf
//zwei Durchlufe
   i=1;
   j=0;
   ud=UP;
   do
    {
     PORTB=0b10000000; //Grnanteil
     Delay100us(i);
     PORTB=0b01000000; //Rotanteil
     Delay100us(255-i);

     if(ud==UP && i<254) i++;
     if(ud==DOWN && i>1) i--;

     if(ud==UP && i==254) { ud=DOWN; j++; }
     if(ud==DOWN && i==1) { ud=UP; j++; }
    }while(j<4); 
//Ende stufenloser Farbverlauf

//Farbsprnge
   PORTB=0b01000000; //Grn
   Delay1ms(255); Delay1ms(255); Delay1ms(255); Delay1ms(255);
   Delay1ms(255); Delay1ms(255); Delay1ms(255); Delay1ms(255);
   Delay1ms(255); Delay1ms(255); Delay1ms(255); Delay1ms(255);

   j=0;
   do   //Ein recht gutes Gelb
    {
     PORTB=0b01000000; //Grnanteil
     Delay100us(215);
     PORTB=0b10000000; //Rotanteil
     Delay100us(40);
     j++;
    }while(j<200);  

   j=0; //Grn und Rot 50%
   do   //Schmutziges Orange
    {
     PORTB=0b01000000; //Grnanteil
     Delay100us(127);
     PORTB=0b10000000; //Rotanteil
     Delay100us(127);
     j++;
    }while(j<200);  

   j=0; //Grn 25% und Rot 75%
   do   //Helles Rot
    {
     PORTB=0b01000000; //Grnanteil
     Delay100us(64);
     PORTB=0b10000000; //Rotanteil
     Delay100us(191);
     j++;
    }while(j<200);  

   PORTB=0b10000000; //Rot
   Delay1ms(255); Delay1ms(255); Delay1ms(255); Delay1ms(255);
   Delay1ms(255); Delay1ms(255); Delay1ms(255); Delay1ms(255);
   Delay1ms(255); Delay1ms(255); Delay1ms(255); Delay1ms(255);
//Ende Farbsprnge
  
  } // Ende Programm Endlosschleife
}

